html {
  min-height: 100%;
  box-sizing: border-box;
}

*, *:before, *:after {
  box-sizing: inherit;
  margin: 0;
  padding: 0;
}

a, a:visited, a:active, a:hover {
  color: inherit;
}

.clear {
  clear: both;
}

body {
  min-height: 100%;
  position: relative;
  font-family: 'Roboto', sans-serif;
  font-size: 12pt;
  font-weight: lighter;

  #grid {
    display: grid;
    max-width: 1200px;
    min-width: 980px;
    min-height: 100vh;
    margin: auto;
    grid-template-rows: 150px 1fr 60px 50px;
    grid-template-columns: 1fr 3fr;
    column-gap: 5px;
    row-gap: 5px;
    grid-template-areas:
      "header header"
      "taskList matrix"
      "downloadButton matrix"
      "footer footer";

    > header {
      grid-area: header;
      text-align: center;
      margin-bottom: 20px;
      padding: 20px 0;
      border-bottom: 1px solid rgba(0,0,0,0.4);

      h1 {
        font-weight: lighter;
        font-size: 28pt;
        margin-bottom: 8px;
      }

      p {
        font-size: 15pt;
      }
    }

    > footer {
      grid-area: footer;
      background: #fff;
      color: #666;
      text-align: center;
      line-height: 50px;
    }
  }
}

#task-list {
  grid-area: taskList;
  position: relative;
  background: rgba(198, 210, 206, 0.32);
  overflow: hidden;

  .tasks-container {
    overflow-y: auto;
    height: calc(100% - 70px);
    width: 100%;
    position: absolute;
  }
  
  header {
    border-bottom: 1px solid rgba(0,0,0,0.4);
    height: 70px;

    h2 {
      font-weight: lighter;
      text-align: center;
      text-transform: uppercase;
      line-height: 70px;
      font-size: 16pt;
    }
  }

  .task {
    padding: 8px 12px;
    position: relative;
    border-bottom: 1px solid rgba(0,0,0,0.4);

    &:last-child {
      border-bottom: none;
    }

    &:after {
      clear: both;
    }

    &.assigned {
      background-color: rgba(72, 72, 72, 0.3);
    }

    &.unassigned {
      background-color: rgba(72, 72, 72, 0.05);
    }

    .left {
      width: 80%;
      float:left;
    }

    .right {
      width: 20%;
      float: right;
    }

    .description {
      font-weight: normal;
    }
    .date {
      font-size: 0.9rem;
    }
  }
}

#matrix {
  grid-area: matrix;
  min-height: 750px;
  background: rgba(150, 20, 150, 0.2);
  position: relative;
  display: grid;
  grid-template-rows: 1fr 1fr;
  grid-template-columns: 1fr 1fr;

  .task {
    background: rgba(255,255,255,0.9);
    padding: 20px;
    font-size: 11pt;
    position: relative;

    &:hover .delete {
      display: block;
    }

    .description {
      border-bottom: 1px solid rgba(0,0,0,0.4);
      text-align: center;
      margin-bottom: 8px;
      font-weight: bold;
    }

    .author {
      word-break: break-all;
    }

    div {
      padding: 5px 0;
    }

    .delete {
      text-align: right;
      cursor: pointer;
      position: absolute;
      top: 5px;
      right: 20px;
      background: #555;
      display: none;

      &:before, &:after {
        position: absolute;
        content: ' ';
        height: 25px;
        width: 2px;
        background-color: #ff7a88;
        padding: 2px;
      }
      &:before {
        transform: rotate(45deg);
      }
      &:after {
        transform: rotate(-45deg);
      }
    }
  }

  .quadrant {
    position: relative;
    display: grid;
    grid-template-rows: 1fr 1fr;
    grid-template-columns: 1fr 1fr;
    column-gap: 10px;
    row-gap: 10px;
    padding: 5px;

    &.many-tasks {
      grid-template-rows: 1fr 1fr 1fr;
      grid-template-columns: 1fr 1fr 1fr;
    }

    &.q1 {
      border-right: 1px solid rgba(0,0,0,0.5);
      border-bottom: 1px solid rgba(0,0,0,0.5);
    }

    &.q2 {
      border-left: 1px solid rgba(0,0,0,0.5);
      border-bottom: 1px solid rgba(0,0,0,0.5);
    }

    &.q3 {
      border-top: 1px solid rgba(0,0,0,0.5);
      border-right: 1px solid rgba(0,0,0,0.5);
    }

    &.q4 {
      border-left: 1px solid rgba(0,0,0,0.5);
      border-top: 1px solid rgba(0,0,0,0.5);
    }

    .background-text {
      text-align: center;
      font-size: 68px;
      font-weight: normal;
      color: rgba(0,0,0,0.2);
      position: absolute;
      left: 0;
      right: 0;
      top: calc(50% - 40px);
      pointer-events: none;
    }
  }

  &:after {
    clear: both;
  }
}

.quadrant {
  &.q1 {
    background: $matrix-green;
  }
  &.q2 {
    background: $matrix-blue;
  }
  &.q3 {
    background: $matrix-yellow;
  }
  &.q4 {
    background: $matrix-red;
  }
}

.matrix-buttons {
  height: 50px;
  width: 50px;
  position: relative;
  cursor: pointer;

  .quadrant {
    width: 40%;
    height: 40%;
    position: absolute;
    filter: brightness(55%);
    opacity: 0.6;
    transition: 100ms;

    &:hover, &.active {
      filter: brightness(110%);
      opacity: 1;
      width: 50%;
      height: 50%;
    }
  }

  .q1 {
    top: 10%;
    left: 10%;

    &:hover, &.active {
      top: 0;
      left: 0;
    }
  }

  .q2 {
    top: 10%;
    right: 10%;

    &:hover, &.active {
      top: 0;
      right: 0;
    }
  }

  .q3 {
    bottom: 10%;
    left: 10%;

    &:hover, &.active {
      bottom: 0;
      left: 0;
    }
  }

  .q4 {
    bottom: 10%;
    right: 10%;

    &:hover, &.active {
      bottom: 0;
      right: 0;
    }
  }
}

button#download {
  grid-area: downloadButton;
  cursor: pointer;
  font-size: 1rem;
}